import { AbstractParseTreeVisitor, Lexer as LexerType, Parser as ParserType } from 'antlr4ng';
import { CursorPosition } from './lib/cursor.js';
import { TokenDictionary } from './lib/tables.js';
import { AutocompleteParseResult, GenerateSuggestionsFromRules, GetParseTree, ISymbolTableVisitor, LexerConstructor, ParserConstructor, SymbolTableVisitorConstructor, TableSuggestion } from './types.js';
export { AutocompleteParseResult, TableSuggestion };
export declare function parseQuery<L extends LexerType, P extends ParserType, V extends AbstractParseTreeVisitor<{}>, S extends ISymbolTableVisitor & V>(Lexer: LexerConstructor<L>, Parser: ParserConstructor<P>, SymbolTableVisitor: SymbolTableVisitorConstructor<S>, tokenDictionary: TokenDictionary, ignoredTokens: Set<number>, preferredRules: Set<number>, explicitlyParseJoin: boolean, getParseTree: GetParseTree<P>, generateSuggestionsFromRules: GenerateSuggestionsFromRules, query: string, cursor: CursorPosition): AutocompleteParseResult;
export declare function parseMySqlQueryWithoutCursor(query: string): Pick<AutocompleteParseResult, 'errors'>;
export declare function parseMySqlQuery(query: string, cursor: CursorPosition): AutocompleteParseResult;
export declare function parsePostgreSqlQueryWithoutCursor(query: string): Pick<AutocompleteParseResult, 'errors'>;
export declare function parsePostgreSqlQuery(query: string, cursor: CursorPosition): AutocompleteParseResult;
export declare function parseClickHouseQueryWithoutCursor(query: string): Pick<AutocompleteParseResult, 'errors'>;
export declare function parseClickHouseQuery(query: string, cursor: CursorPosition): AutocompleteParseResult;
