import { ParseTree, Token } from 'antlr4ng';
import * as c3 from 'antlr4-c3';
import { AutocompleteParseResult, ISymbolTableVisitor } from '../../types.js';
import { ClickHouseLexer } from './generated/ClickHouseLexer.js';
import { ClickHouseParser, TableExprAliasContext, TableIdentifierContext } from './generated/ClickHouseParser.js';
import { ClickHouseParserVisitor } from './generated/ClickHouseParserVisitor.js';
import { TableQueryPosition, TokenDictionary } from '../../lib/tables.js';
declare class ClickHouseSymbolTableVisitor extends ClickHouseParserVisitor<{}> implements ISymbolTableVisitor {
    symbolTable: c3.SymbolTable;
    scope: c3.ScopedSymbol;
    constructor();
    visitTableIdentifier: (context: TableIdentifierContext) => {};
    visitTableExprAlias: (context: TableExprAliasContext) => {};
}
declare function generateSuggestionsFromRules(rules: c3.CandidatesCollection['rules'], cursorTokenIndex: number, previousToken?: Token): Partial<AutocompleteParseResult> & {
    suggestColumns?: boolean;
};
declare function getParseTree(parser: ClickHouseParser, type?: TableQueryPosition['type']): ParseTree;
export declare const clickHouseParserData: {
    Lexer: typeof ClickHouseLexer;
    Parser: typeof ClickHouseParser;
    SymbolTableVisitor: typeof ClickHouseSymbolTableVisitor;
    tokenDictionary: TokenDictionary;
    ignoredTokens: Set<number>;
    preferredRules: Set<number>;
    explicitlyParseJoin: boolean;
    getParseTree: typeof getParseTree;
    generateSuggestionsFromRules: typeof generateSuggestionsFromRules;
};
export {};
