import { ParseTree, Token } from 'antlr4ng';
import * as c3 from 'antlr4-c3';
import { AutocompleteParseResult, ISymbolTableVisitor } from '../../types.js';
import { MySqlLexer } from './generated/MySqlLexer.js';
import { AtomTableItemContext, MySqlParser, TableNameContext } from './generated/MySqlParser.js';
import { MySqlParserVisitor } from './generated/MySqlParserVisitor.js';
import { TableQueryPosition, TokenDictionary } from '../../lib/tables.js';
declare class MySqlSymbolTableVisitor extends MySqlParserVisitor<{}> implements ISymbolTableVisitor {
    symbolTable: c3.SymbolTable;
    scope: c3.ScopedSymbol;
    constructor();
    visitTableName: (context: TableNameContext) => {};
    visitAtomTableItem: (context: AtomTableItemContext) => {};
}
declare function generateSuggestionsFromRules(rules: c3.CandidatesCollection['rules'], cursorTokenIndex: number, previousToken?: Token): Partial<AutocompleteParseResult> & {
    suggestColumns?: boolean;
};
declare function getParseTree(parser: MySqlParser, type?: TableQueryPosition['type']): ParseTree;
export declare const mySqlParserData: {
    Lexer: typeof MySqlLexer;
    Parser: typeof MySqlParser;
    SymbolTableVisitor: typeof MySqlSymbolTableVisitor;
    tokenDictionary: TokenDictionary;
    ignoredTokens: Set<number>;
    preferredRules: Set<number>;
    explicitlyParseJoin: boolean;
    getParseTree: typeof getParseTree;
    generateSuggestionsFromRules: typeof generateSuggestionsFromRules;
};
export {};
