import { ParseTree, Token } from 'antlr4ng';
import * as c3 from 'antlr4-c3';
import { AutocompleteParseResult, ISymbolTableVisitor } from '../../types.js';
import { PostgreSqlLexer } from './generated/PostgreSqlLexer.js';
import { PostgreSqlParser, Relation_exprContext, Table_refContext } from './generated/PostgreSqlParser.js';
import { PostgreSqlParserVisitor } from './generated/PostgreSqlParserVisitor.js';
import { TableQueryPosition, TokenDictionary } from '../../lib/tables.js';
declare class PostgreSqlSymbolTableVisitor extends PostgreSqlParserVisitor<{}> implements ISymbolTableVisitor {
    symbolTable: c3.SymbolTable;
    scope: c3.ScopedSymbol;
    constructor();
    visitRelation_expr: (context: Relation_exprContext) => {};
    visitTable_ref: (context: Table_refContext) => {};
}
declare function generateSuggestionsFromRules(rules: c3.CandidatesCollection['rules'], cursorTokenIndex: number, previousToken?: Token): Partial<AutocompleteParseResult> & {
    suggestColumns?: boolean;
};
declare function getParseTree(parser: PostgreSqlParser, type?: TableQueryPosition['type']): ParseTree;
export declare const postgreSqlParserData: {
    Lexer: typeof PostgreSqlLexer;
    Parser: typeof PostgreSqlParser;
    SymbolTableVisitor: typeof PostgreSqlSymbolTableVisitor;
    tokenDictionary: TokenDictionary;
    ignoredTokens: Set<number>;
    preferredRules: Set<number>;
    explicitlyParseJoin: boolean;
    getParseTree: typeof getParseTree;
    generateSuggestionsFromRules: typeof generateSuggestionsFromRules;
};
export {};
